Перем КодВыполнения;
Перем ЧастиШаблона;
Перем РамкиБлоков;
Перем СоответствияРамокБлоков;

Перем ТекстШаблона;

Процедура ПриСозданииОбъекта(Текст)

	ТекстШаблона = Текст;

	РамкиБлоков = Новый Структура();
	РамкиБлоков.Вставить("НачалоВыражения", 	МассивИзДвухСимволов("{", "{"));
	РамкиБлоков.Вставить("ОкончаниеВыражения", 	МассивИзДвухСимволов("}", "}"));
	РамкиБлоков.Вставить("НачалоОператора", 	МассивИзДвухСимволов("{", "%"));
	РамкиБлоков.Вставить("ОкончаниеОператора", 	МассивИзДвухСимволов("%", "}"));

	СоответствияРамокБлоков = Новый Соответствие;
	СоответствияРамокБлоков.Вставить(СтрСоединить(РамкиБлоков.НачалоВыражения, ""), РамкиБлоков.ОкончаниеВыражения);
	СоответствияРамокБлоков.Вставить(СтрСоединить(РамкиБлоков.НачалоОператора, ""), РамкиБлоков.ОкончаниеОператора);


КонецПроцедуры

Процедура ИнициализацияПеременных()

	КодВыполнения = Новый Массив();
	ЧастиШаблона = Новый Соответствие();
	
КонецПроцедуры

Функция СформироватьТекст(Контекст = Неопределено) Экспорт

	ИнициализацияПеременных();
	
	БлокПоиска = Новый Массив(2);
	ТекущийПоток = Новый Массив;


	ИскомоеОкочание = Неопределено;

	Для Сч = 1 по СтрДлина(ТекстШаблона) Цикл
		ТекущийСимвол = Сред(ТекстШаблона, Сч, 1);
		ДобавитьВМассивСоСмещением(БлокПоиска, ТекущийСимвол);
		
		Если МассивыРавны(БлокПоиска, РамкиБлоков.НачалоВыражения) 
				или МассивыРавны(БлокПоиска, РамкиБлоков.НачалоОператора) Тогда		
			Ид = ДобавитьЧастьШаблона(ТекущийПоток);
			ТекущийПоток = Новый Массив;
			ИскомоеОкочание = ПолучитьЗакрывающийТег(БлокПоиска);
			ЧастьКодаВставкаЧастиШаблона(Ид);

		ИначеЕсли Не ИскомоеОкочание = Неопределено 
					И МассивыРавны(БлокПоиска, ИскомоеОкочание) Тогда
			ЧастьКода = СтрокаИзМассива(ТекущийПоток);
			ТекущийПоток = Новый Массив;
			ДобавитьЧастьКодаОтОкочания(ЧастьКода, ИскомоеОкочание);
			ИскомоеОкочание = Неопределено;	

		Иначе
			ТекущийПоток.Добавить(ТекущийСимвол);
		КонецЕсли;
	КонецЦикла;

	Если ТекущийПоток.Количество() > 0 Тогда
		ТекущийПоток.Добавить(" ");
		Ид = ДобавитьЧастьШаблона(ТекущийПоток);
		ЧастьКодаВставкаЧастиШаблона(Ид);
	КонецЕсли;

	Результат = Новый Массив;

	ЗаполнитьМассивКодом(Результат, Контекст);

	ТекстОтображения = СтрСоединить(Результат, "");

	Возврат ТекстОтображения;

КонецФункции

Процедура ЗаполнитьМассивКодом(Результат, Контекст)

	// Для обратной совместимости в winow
	Модель = Контекст;

	ВесьКод = СтрСоединить(КодВыполнения);
	Выполнить(ВесьКод);
	
КонецПроцедуры

Процедура ДобавитьЧастьКодаОтОкочания(ЧастьКода, Окончание)

	Если Окончание = РамкиБлоков.ОкончаниеВыражения Тогда
		КодКДобавлению = СтрШаблон("_Значение = Строка(%1);
									|Результат.Добавить(_Значение);", ЧастьКода);
		КодВыполнения.Добавить(КодКДобавлению + Символы.ПС);
	Иначе
		КодВыполнения.Добавить(ЧастьКода + Символы.ПС);
	КонецЕсли;

КонецПроцедуры

Процедура ЧастьКодаВставкаЧастиШаблона(Ид)

	Код = СтрШаблон("Результат.Добавить(ЧастиШаблона[""%1""]);", Ид);
	КодВыполнения.Добавить(Код + Символы.ПС);
	
КонецПроцедуры

Функция ДобавитьЧастьШаблона(МассивСимволов)

	Строка = СтрокаИзМассива(МассивСимволов);
	Ид = ХешироватьСтроку(Строка);
	
	ЧастиШаблона.Вставить(Ид, Строка);

	Возврат Ид;
	
КонецФункции

Функция СтрокаИзМассива(МассивСимволов)
	МассивСимволов.Удалить(МассивСимволов.ВГраница());
	Строка = СтрСоединить(МассивСимволов, "");
	Возврат Строка; 	
КонецФункции

Функция ХешироватьСтроку(Строка)  
	
	Хеширование = Новый ХешированиеДанных(ХешФункция.MD5);
	
	Хеширование.Добавить(Строка);
	
	Возврат Base64Строка(Хеширование.ХешСумма);
	
КонецФункции

Функция МассивИзДвухСимволов(Символ1, Символ2)

	Массив = Новый Массив(2);
	Массив[0] = Символ1;
	Массив[1] = Символ2;
	
	Возврат Массив;

КонецФункции

Функция ПолучитьЗакрывающийТег(ОткрывающийТег)

	Возврат СоответствияРамокБлоков.Получить(СтрСоединить(ОткрывающийТег,""));	

КонецФункции

Функция МассивыРавны(Массив1, Массив2)

	Если не Массив1.Количество() = Массив2.Количество() Тогда
		Возврат Ложь;
	Иначе
		Для сч = 0 По Массив1.ВГраница() Цикл
			Если Не Массив1[сч] = Массив2[сч] Тогда
				Возврат Ложь;
			КонецЕсли;
		КонецЦикла;
	КонецЕсли;

	Возврат Истина;
	
КонецФункции

Процедура ДобавитьВМассивСоСмещением(Массив, ДобавляемыйЭлемент)
	
	Если Массив.Количество() = 1 Тогда
		Массив[0] = ДобавляемыйЭлемент;
		Возврат;
	ИначеЕсли Массив.Количество() = 0 Тогда
		ВызватьИсключение "Пустой массив для смещения";
	КонецЕсли;

	Для сч = 0 по Массив.ВГраница() - 1 Цикл
		Массив[сч] = Массив[сч + 1];
	КонецЦикла;

	Массив[Массив.ВГраница()] = ДобавляемыйЭлемент;

КонецПроцедуры

Функция ВывестиПоШаблону(ТекстШаблона, Контекст)

	ВложенныйШаблон = НовыйЭкземплярШаблона(ТекстШаблона); 
	
	Возврат ВложенныйШаблон.СформироватьТекст(Контекст);

КонецФункции

Функция НовыйЭкземплярШаблона(ТекстШаблона)

	Возврат Новый Шаблон(ТекстШаблона);

КонецФункции 